#include <bits/stdc++.h>
using namespace std;
#define ll long long

int main() {
    ios_base::sync_with_stdio(false);
    string a[10];
    for (int i = 0; i < 10; i++) {
        cin >> a[i];
    }

    int ship_counts[5] = {0};  // Массив для подсчета количества кораблей разных размеров (0, 1, 2, 3, 4)

    for (int i = 0; i < 10; i++) {
        for (int j = 0; j < 10; j++) {
            if (a[i][j] == '#') {
                int size = 0;
                // Проверка корабля по горизонтали
                for (int k = j; k < 10 && a[i][k] == '#'; k++) {
                    size++;
                }
                // Проверка корабля по вертикали
                for (int k = i; k < 10 && a[k][j] == '#'; k++) {
                    size++;
                }
                ship_counts[size]++;
                if (size > 4) {
                    cout << "NO";
                    return 0;
                }
            }
        }
    }

    // Проверка количества кораблей
    if (ship_counts[1] == 4 && ship_counts[2] == 3 && ship_counts[3] == 2 && ship_counts[4] == 1) {
        cout << "YES";
    } else {
        cout << "NO";
    }

    return 0;
}
